# coding: utf-8

"""
    Cashfree Payment Gateway APIs

    Cashfree's Payment Gateway APIs provide developers with a streamlined pathway to integrate advanced payment processing capabilities into their applications, platforms and websites.

    The version of the OpenAPI document: 2022-09-01
    Contact: developers@cashfree.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel
from cashfree_pg.models.settlement_entity import SettlementEntity

class SettlementWebhookDataEntity(BaseModel):
    """
    data entity in webhook
    """
    settlement: Optional[SettlementEntity] = None
    __properties = ["settlement"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SettlementWebhookDataEntity:
        """Create an instance of SettlementWebhookDataEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of settlement
        if self.settlement:
            _dict['settlement'] = self.settlement.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SettlementWebhookDataEntity:
        """Create an instance of SettlementWebhookDataEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SettlementWebhookDataEntity.parse_obj(obj)

        _obj = SettlementWebhookDataEntity.parse_obj({
            "settlement": SettlementEntity.from_dict(obj.get("settlement")) if obj.get("settlement") is not None else None
        })
        return _obj


